#define __USE_ATFILE
#define __USE_GNU
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <errno.h>

#define AT_NO_AUTOMOUNT		0x800

/*
 * Assumes autofs setup
 * /etc/auto.master:
 * /test	auto.indirect
 * /-		auto.direct
 *
 * /etc/auto.indirect
 * # Non-existent export
 * autofs	<some server>:/autofs
 * # Valid automount
 * Public       <some server>:/Public
 *
 * /etc/auto.direct
 * # Non-existent export
 * /dtest/s1	-nfsvers=3,tcp <some server>:/autofs
 * # Valid automount
 * /dtest/s2    -nfsvers=3,tcp <some server>:/Public
 */

void do_fstatat(char *path, int flags)
{
	struct stat buf;
	int ret;

	ret = fstatat(-1, path, &buf, flags);
	if (ret)
		printf("error: path %s, %s\n", path, strerror(errno));
	else
		printf("path %s, st_dev %u st_ino %u\n",
			path, buf.st_dev, buf.st_ino);
}

int main(int argc, char **argv)
{
	char *path1 = "/test";
	char *path2 = "/test/Public";
	char *path3 = "/test/autofs";
	char *path4 = "/test/.hidden";
	char *path5 = "/dtest/s1";
	char *path6 = "/dtest/s1/.hidden";
	char *path7 = "/dtest/s2";
	char *path8 = "/dtest/s2/.hidden";
	int flags = AT_NO_AUTOMOUNT;
	/*int flags = 0;*/
	int ret;

	do_fstatat(path1, flags);
	do_fstatat(path2, flags);
	do_fstatat(path3, flags);
	do_fstatat(path4, flags);
	do_fstatat(path5, flags);
	do_fstatat(path6, flags);
	do_fstatat(path7, flags);
	/*do_fstatat(path8, flags);*/
}
